package com.ynet.life.mvc.upload;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEConstance;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.gene.flow.GENEFlow;
import com.ynet.gene.log.GENELog;
import com.ynet.gene.session.Session;
import com.ynet.gene.transaction.GENETransactionManager;
import com.ynet.gene.web.multipart.GENEMultipartHttpServletRequest;
import com.ynet.gene.web.multipart.MultipartHttpServletRequest;
import com.ynet.gene.web.multipart.UploadStatusListener;
import com.ynet.gene.web.multipart.implement.GENEMultipartFile;
import com.ynet.gene.web.servlet.ModelAndView;
import com.ynet.gene.web.servlet.mvc.GENEFlowExecuteResult;
import com.ynet.life.base.LifeErrorInfo;
import com.ynet.life.base.LifePlatManager;
import com.ynet.life.base.LifeStandard;
import com.ynet.life.base.TEntity;
import com.ynet.life.base.Trace;
import com.ynet.life.exception.TranFailException;
import com.ynet.life.exception.UploadFileFailedException;
import com.ynet.life.file.LifeFile;
import java.io.File;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUploadBase;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

/* loaded from: com_ynet_life_mvc_upload.jar:com/ynet/life/mvc/upload/PicUploadViewRequestController.class */
public class PicUploadViewRequestController extends UploadController {
    private static final String ERROR_CODE_FIELD = "errorCodeField";
    private static final String ERROR_MSG_FIELD = "errorMsgField";
    private static final String DEFAULT_ERROR_CODE = "EBLN0000";
    private long maxFileSize = 512000;
    private int bufferSize = 10240;
    private String tempFileFolder = null;
    private String uploadFileFolder = null;
    private boolean tmpFile = true;
    private Map mvcMap = new HashMap();

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v151, types: [java.lang.Object] */
    /* JADX WARN: Type inference failed for: r0v91 */
    /* JADX WARN: Type inference failed for: r0v92 */
    @Override // com.ynet.life.mvc.upload.UploadController
    public ModelAndView doRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
        String ec;
        String errorMsg;
        String ec2;
        String errorMsg2;
        String ec3;
        String errorMsg3;
        String ec4;
        String errorMsg4;
        if (this.openMonitor) {
            this.accessInfo.newAccess();
        }
        Map model = new HashMap();
        UploadView uploadView = new UploadView();
        String mvcName = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        try {
            if (isMultipart(request)) {
                GENEMultipartHttpServletRequest theRequest = resolverMultipart(request, null);
                UploadRequest mvc = (UploadRequest) this.mvcMap.get(mvcName);
                Context sessionContext = null;
                if (mvc.isCheckSession()) {
                    try {
                        Session session = doSessionCheck(theRequest, response);
                        if (session == null) {
                            Trace.logError("LifeSession", "Session not exist or timeout");
                            model.put(ERROR_CODE_FIELD, "EBLN1000");
                            return new ModelAndView(model, uploadView);
                        }
                        sessionContext = (Context) session.getAttribute(GENEConstance.ATTR_CONTEXT);
                        theRequest.setAttribute(GENEConstance.GENE_SESSION, session);
                    } catch (Exception unused) {
                        Trace.logError("LifeSession", "Session not exist or timeout");
                        model.put(ERROR_CODE_FIELD, "EBLN1000");
                        return new ModelAndView(model, uploadView);
                    }
                }
                if (sessionContext != null) {
                    try {
                        preActionWork(theRequest, sessionContext, mvc);
                    } catch (Exception e) {
                        Trace.logError("LifeFile", e.getMessage());
                        if (e instanceof GENEException) {
                            ec2 = e.getErrorCode();
                            String showMessage = e.getShowMessage();
                            errorMsg2 = showMessage;
                            if (showMessage == null || "".equals(errorMsg2)) {
                                LifeErrorInfo errorInfo = LifeStandard.getErrorInfo(ec2);
                                errorMsg2 = errorInfo != null ? errorInfo.getShowMsg() : "";
                            }
                        } else {
                            ec2 = DEFAULT_ERROR_CODE;
                            errorMsg2 = e.getMessage();
                        }
                        model.put(ERROR_CODE_FIELD, ec2);
                        model.put(ERROR_MSG_FIELD, errorMsg2);
                        return new ModelAndView(model, uploadView);
                    }
                }
                ?? r0 = 0;
                try {
                    try {
                        GENEFlowExecuteResult result = executeGENELogic(sessionContext, theRequest, response);
                        Context context = result.context;
                        KeyedCollection output = result.flow.getOutput(mvc.getOpId());
                        model.put(GENEConstance.ATTR_CONTEXT, context);
                        model.put(GENEConstance.ATTR_FLOW_OUTPUT, output);
                        if (result.e != null) {
                            Trace.logError(GENEConstance.GENE_MVC, result.e.getMessage(), result.e);
                            if (result.e instanceof GENEException) {
                                ec4 = result.e.getErrorCode();
                                String showMessage2 = result.e.getShowMessage();
                                errorMsg4 = showMessage2;
                                if (showMessage2 == null || "".equals(errorMsg4)) {
                                    LifeErrorInfo errorInfo2 = LifeStandard.getErrorInfo(ec4);
                                    errorMsg4 = errorInfo2 != null ? errorInfo2.getShowMsg() : "";
                                }
                            } else {
                                ec4 = DEFAULT_ERROR_CODE;
                                errorMsg4 = result.e.getMessage();
                            }
                            model.put(ERROR_CODE_FIELD, ec4);
                            r0 = model.put(ERROR_MSG_FIELD, errorMsg4);
                        }
                        if (sessionContext != null) {
                            pstActionWork(theRequest, sessionContext, mvc, null);
                        }
                        return new ModelAndView(model, uploadView);
                    } catch (Throwable th) {
                        if (sessionContext != null) {
                            pstActionWork(theRequest, sessionContext, mvc, null);
                        }
                        throw th;
                    }
                } catch (Exception e2) {
                    Exception actionEx = r0;
                    Trace.logError("LifeFile", e2.getMessage());
                    if (e2 instanceof GENEException) {
                        ec3 = e2.getErrorCode();
                        String showMessage3 = e2.getShowMessage();
                        errorMsg3 = showMessage3;
                        if (showMessage3 == null || "".equals(errorMsg3)) {
                            LifeErrorInfo errorInfo3 = LifeStandard.getErrorInfo(ec3);
                            errorMsg3 = errorInfo3 != null ? errorInfo3.getShowMsg() : "";
                        }
                    } else {
                        ec3 = DEFAULT_ERROR_CODE;
                        errorMsg3 = e2.getMessage();
                    }
                    model.put(ERROR_CODE_FIELD, ec3);
                    model.put(ERROR_MSG_FIELD, errorMsg3);
                    ModelAndView modelAndView = new ModelAndView(model, uploadView);
                    if (sessionContext != null) {
                        pstActionWork(theRequest, sessionContext, mvc, actionEx);
                    }
                    return modelAndView;
                }
            }
            Trace.logError("LifeFile", String.valueOf(mvcName) + "没有文件上传权限");
            model.put(ERROR_CODE_FIELD, DEFAULT_ERROR_CODE);
            model.put(ERROR_MSG_FIELD, String.valueOf(mvcName) + "没有文件上传权限");
            return new ModelAndView(model, uploadView);
        } catch (Exception e3) {
            Trace.logError("LifeFile", e3.getMessage());
            if (e3 instanceof GENEException) {
                ec = e3.getErrorCode();
                String showMessage4 = e3.getShowMessage();
                errorMsg = showMessage4;
                if (showMessage4 == null || "".equals(errorMsg)) {
                    LifeErrorInfo errorInfo4 = LifeStandard.getErrorInfo(ec);
                    errorMsg = errorInfo4 != null ? errorInfo4.getShowMsg() : "";
                }
            } else {
                ec = DEFAULT_ERROR_CODE;
                errorMsg = e3.getMessage();
            }
            model.put(ERROR_CODE_FIELD, ec);
            model.put(ERROR_MSG_FIELD, errorMsg);
            return new ModelAndView(model, uploadView);
        }
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    protected GENEFlowExecuteResult executeGENELogic(Context sessionContext, GENEMultipartHttpServletRequest request, HttpServletResponse response) {
        String mvcName = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        UploadRequest mvc = (UploadRequest) this.mvcMap.get(mvcName);
        GENEFlowExecuteResult result = new GENEFlowExecuteResult();
        GENETransactionManager transactionManager = null;
        String flowId = mvc.getBizId();
        GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "begin to execute flow " + flowId + " ...");
        String opId = mvc.getOpId();
        try {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Get flow " + flowId + "  from factory...");
            GENEFlow flow = this.geneFactory.getGENEFlow(flowId);
            result.flow = flow;
            Context context = (Context) flow.getContext().clone();
            result.context = context;
            if (sessionContext != null && context.getParentContextName() == null) {
                context.chainedTo(sessionContext);
            } else {
                GENELog.log(GENEConstance.GENE_MVC, GENELog.WARNING, 0, "The sessionContext is null , maybe a unvalid session request ...");
            }
            transactionManager = (GENETransactionManager) context.getService(GENEConstance.TRX_SVC_NAME);
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Update the request data ...");
            doUpdateModel(request, context, flow, opId);
            doPreprocessModelData(request, context, flow, opId);
            addDataField(context, GENEConstance.SERVLET_REQUEST, request);
            preContextWork(request, sessionContext, context, mvc);
            String retValue = flow.execute(context, opId);
            if (transactionManager != null) {
                transactionManager.commit();
            }
            result.result = retValue;
        } catch (Exception e) {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.ERROR, 0, "Failed to execute flow ".concat(String.valueOf(flowId)), e);
            result.e = e;
            if (transactionManager != null) {
                transactionManager.rollback();
            }
        }
        return result;
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public void addUploadRequest(UploadRequest mvc) {
        this.mvcMap.put(mvc.getId(), mvc);
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public boolean isMultipart(HttpServletRequest request) {
        return ServletFileUpload.isMultipartContent(request);
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public GENEMultipartHttpServletRequest resolverMultipart(HttpServletRequest request, UploadStatusListener listener) throws GENEException {
        String mvcName = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        UploadRequest mvc = (UploadRequest) this.mvcMap.get(mvcName);
        if (mvc == null) {
            Trace.logError("LifeFile", String.valueOf(mvcName) + "没有文件上传权限");
            throw new TranFailException(DEFAULT_ERROR_CODE, String.valueOf(mvcName) + "没有文件上传权限");
        }
        DiskFileItemFactory factory = new DiskFileItemFactory(this.bufferSize, new File(getTempUploadDir()));
        ServletFileUpload upload = new ServletFileUpload(factory);
        upload.setSizeMax(getMaxFileSize(mvc));
        try {
            List<FileItem> items = upload.parseRequest(request);
            Map parameters = new HashMap();
            new HashMap();
            Map fileMap = new HashMap();
            for (FileItem item : items) {
                String fieldName = item.getFieldName();
                if (!item.isFormField()) {
                    String originalFileName = item.getName();
                    if (originalFileName.length() > 0) {
                        mvc.validateType(item);
                        String uploadPath = getUploadDirectory();
                        String finalFileName = getFileName(originalFileName);
                        String finalFilePathName = String.valueOf(uploadPath) + finalFileName;
                        File uploadedFile = new File(finalFilePathName);
                        try {
                            item.write(uploadedFile);
                            Trace.logDebug("LifeFile", "文件[" + finalFilePathName + "]上传成功");
                            if (mvc.isAbsoluteFile()) {
                                fileMap.put(fieldName, new GENEMultipartFile(fieldName, finalFilePathName, originalFileName));
                            } else {
                                fileMap.put(fieldName, new GENEMultipartFile(fieldName, finalFileName, originalFileName));
                            }
                            addParameter(fieldName, originalFileName, parameters);
                        } catch (Exception ex) {
                            Trace.logError("LifeFile", "文件[" + finalFilePathName + "]上传失败", ex);
                            throw new TranFailException(DEFAULT_ERROR_CODE, "文件[" + finalFilePathName + "]上传失败", ex);
                        }
                    }
                }
                if (item.isFormField()) {
                    try {
                        String fieldValue = item.getString("UTF-8");
                        addParameter(fieldName, fieldValue, parameters);
                    } catch (UnsupportedEncodingException e) {
                        Trace.logWarning("LifeFile", "不支持的编码", e);
                    }
                }
            }
            return new GENEMultipartHttpServletRequest(request, parameters, fileMap);
        } catch (FileUploadBase.SizeLimitExceededException ex2) {
            Trace.logError("LifeFile", "文件上传大小超过[" + (getMaxFileSize(mvc) / 1024) + " KB]限制", ex2);
            throw new UploadFileFailedException("文件上传大小超过[" + (getMaxFileSize(mvc) / 1024) + " KB]限制");
        } catch (FileUploadException ex3) {
            Trace.logError("LifeFile", "文件上传请求处理失败", ex3);
            throw new TranFailException(DEFAULT_ERROR_CODE, "文件上传请求处理失败", ex3);
        }
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public void cleanup(MultipartHttpServletRequest request) {
    }

    private long getMaxFileSize(UploadRequest mvc) {
        long mvcMaxSize = mvc.getMaxFileSize();
        return mvcMaxSize > 0 ? mvcMaxSize : this.maxFileSize;
    }

    private void checkFolder(String folderPath) {
        if (!new File(folderPath).isDirectory()) {
            Trace.logError("LifeFile", "本地目录--->" + folderPath + " 不可用");
            LifeFile.makeMultiDirectory(folderPath);
        }
    }

    private void addParameter(String key, String value, Map map) {
        Object preValueObj = map.get(key);
        if (preValueObj == null) {
            map.put(key, new String[]{value});
            return;
        }
        int len = ((String[]) preValueObj).length;
        String[] sArr = new String[len + 1];
        System.arraycopy(preValueObj, 0, sArr, 0, len);
        sArr[len] = value.trim();
        map.put(key, sArr);
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    protected String getUploadDirectory() {
        String dir;
        if (!this.tmpFile) {
            dir = String.valueOf(LifeFile.getFileRootPath()) + this.uploadFileFolder + LifeFile.DIR_SEPARATOR;
        } else {
            dir = String.valueOf(LifeFile.getTempFileRootPath()) + this.uploadFileFolder + LifeFile.DIR_SEPARATOR + LifeStandard.getServerTime("yyyyMMdd") + LifeFile.DIR_SEPARATOR;
        }
        checkFolder(dir);
        return dir;
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    protected String getTempUploadDir() {
        String dir = String.valueOf(LifeFile.getTempFileRootPath()) + this.tempFileFolder + LifeFile.DIR_SEPARATOR;
        checkFolder(dir);
        return dir;
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    protected String getFileName(String fileName) {
        String generateName = String.valueOf(LifeStandard.getServerTime("yyyyMMddHHmmssSSS")) + new Random().nextInt(1000);
        int dotPos = fileName.lastIndexOf(".");
        if (dotPos > 0) {
            return String.valueOf(generateName) + fileName.substring(dotPos);
        }
        return generateName;
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public void setMaxFileSize(String maxFileSize) {
        this.maxFileSize = Long.parseLong(maxFileSize);
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public void setBufferSize(String bufferSize) {
        this.bufferSize = Integer.parseInt(bufferSize);
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public void setTempFileFolder(String tempFileFolder) {
        this.tempFileFolder = tempFileFolder;
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public void setUploadFileFolder(String uploadFileFolder) {
        this.uploadFileFolder = uploadFileFolder;
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public boolean isInCharge(HttpServletRequest request) {
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        if (this.mvcMap != null && this.mvcMap.get(actionId) != null) {
            return true;
        }
        return false;
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    protected void preActionWork(HttpServletRequest request, Context sessionContext, UploadRequest mvc) throws TranFailException {
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    protected void pstActionWork(HttpServletRequest request, Context sessionContext, UploadRequest mvc, Throwable throwable) throws TranFailException {
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    protected void preContextWork(HttpServletRequest request, Context sessionContext, Context context, UploadRequest mvc) throws TranFailException {
        String dataSourceName = LifePlatManager.getBankDBSource("060000");
        context.put(TEntity.dataSourceName, dataSourceName);
        String uploadFileNameFiled = mvc.getUploadFileNameFiled();
        if (uploadFileNameFiled != null && !"".equals(uploadFileNameFiled)) {
            GENEMultipartFile uploadFileInfo = (GENEMultipartFile) context.get("uploadFile");
            if (uploadFileInfo != null) {
                context.put(uploadFileNameFiled, uploadFileInfo.getTempFileName());
            } else {
                Trace.logError("LifeFile", "上传文件为空。");
                throw new TranFailException(DEFAULT_ERROR_CODE, "上传文件为空。");
            }
        }
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public boolean isTmpFile() {
        return this.tmpFile;
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public void setTmpFile(boolean tmpFile) {
        this.tmpFile = tmpFile;
    }

    @Override // com.ynet.life.mvc.upload.UploadController
    public ModelAndView handleException(HttpServletRequest request, HttpServletResponse response, Exception e) {
        Map model = new HashMap();
        model.put(GENEConstance.ATTR_EXCEPTION, e);
        return new ModelAndView(model, new UploadView());
    }
}
